package com.mwe2Maventest.problem.print;

import static org.junit.Assert.fail;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import org.eclipse.emf.mwe2.launch.runtime.Mwe2Launcher;
import org.junit.Assert;
import org.junit.Test;

public class PrintMessageTest {

	@Test
	public void testFileGenM1() {
		String message = "message from test 1";
		runner(message);
		String fileContents = getFileContents("test-gen/printMessage.txt");
		Assert.assertTrue("Test not found in file:" + message, fileContents.contains(message));
	}

	@Test
	public void testFileGenM2() {
		String message = "message from test 2";
		runner(message);
		String fileContents = getFileContents("test-gen/printMessage.txt");
		Assert.assertTrue("Test not found in file:" + message, fileContents.contains(message));
	}

	@Test
	public void testFileGenM3() {
		String message = "message from test 3";
		runner(message);
		String fileContents = getFileContents("test-gen/printMessage.txt");
		Assert.assertTrue("Test not found in file:" + message, fileContents.contains(message));
	}

	private void runner(String message) {
		Mwe2Launcher mwe2launcher = new Mwe2Launcher();
		String[] args = new String[3];

		args[0] = "workflow.PrintToFile";
		args[1] = "-p";
		args[2] = "message=" + message;
		mwe2launcher.run(args);
	}

	private String getFileContents(String filePath) {
		String fileContent = null;
		try {
			fileContent = readFileAsString((new File(filePath)).getAbsolutePath());
		} catch (IOException e) {
			fail("Failed reading file " + filePath + ".");
			e.printStackTrace();
		}
		return fileContent;
	}
	
    public String readFileAsString(String filePath) throws java.io.IOException {
        byte[] buffer = new byte[(int) new File(filePath).length()];
        BufferedInputStream f = null;
        try {
            f = new BufferedInputStream(new FileInputStream(filePath));
            f.read(buffer);
        } finally {
            if (f != null) {
                try { 
                    f.close(); 
                } 
                catch (IOException e) { 
                    e.printStackTrace();
                }
            }
        }
        return new String(buffer);
    }
}
